import { type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrUserservermap {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  UserName?: string;
  UserId!: bigint;
  ServerId!: bigint;
  ExpireDate?: Date;
  Status!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  ClassId!: bigint & Opt;
}

export const IcrUserservermapSchema = defineEntity({
  class: IcrUserservermap,
  comment: '学生和服务器的关系',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    UserName: p.string().name('UserName').nullable().comment('姓名'),
    UserId: p.bigint().name('UserId').comment('用户id'),
    ServerId: p.bigint().name('ServerId').comment('服务器id'),
    ExpireDate: p.datetime().name('ExpireDate').length(3).nullable().comment('过期时间(天)'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    ClassId: p.bigint().name('ClassId').comment('班级id').defaultRaw(`0`),
  },
});
